/*
  copyright(c) 2004  Miki Akiyoshi
  
  This file is part of Miki English Study.
  
  Miki English Study is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  Miki English Study is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with Miki English Study; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  
*/

package jp.dip.ikim.englishstudy ;

import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import javax.swing.event.* ;
import java.io.* ;
import java.util.* ;
import java.text.* ;
import java.awt.dnd.* ;

public class mkLeftWidget implements Serializable
{
    private boolean update_flag = false ;

    private mkCard _cuCard ;
    private DefaultListModel[] _lmodel ;

    public void setUpdateFlag(boolean arg)
    {
	update_flag = arg ;
    }

    public boolean updatep()
    {
	return update_flag ;
    }


    public mkLeftWidget()
    {
	super() ;

    }

    private JPanel _panel ;

    public JPanel getPanel()
    {
	return _panel ;
    }

    transient private mkApplet _app ;

    private  JTextField _name ; 
    private  JTextField _jname ; 

    private  JList    _list ;


    public String getName()
    {
	return _name.getText() ;
    }


    public void setName(String arg)
    {
	 _name.setText(arg) ;
    }


    public String getJName()
    {
	return _jname.getText() ;
    }


    public void setJName(String arg)
    {
	_jname.setText(arg) ;
    }


    public JPanel create(mkApplet arg)
    {
	_app = arg ;

	JLabel lb = null ;
	_panel = new JPanel(null) ;
	_panel.setBounds(0, 10, 300, 650) ;

	JButton but = new JButton("o^(R)") ;
	but.setMnemonic(KeyEvent.VK_R);
	but.setBounds(5, 5, 80,30) ;
	but.addActionListener(new mkGoAction(_app)) ;
	_panel.add(but) ;

	but = new JButton("폜") ;
	but.setMnemonic(KeyEvent.VK_D);
	but.addActionListener(new mkDelAction(_app)) ;
	but.setBounds(90, 5, 70,30) ;
	_panel.add(but) ;

	but = new JButton("pa(T)") ;
	but.setMnemonic(KeyEvent.VK_T);
	but.addActionListener(new mkTransAction(_app)) ;
	but.setBounds(175, 5, 80,30) ;
	_panel.add(but) ;

	lb = new JLabel("Word") ;
	lb.setBounds(5, 45, 100,30) ;
	_panel.add(lb) ;

	_name = new JTextField() ;
	_name.setBounds(115,45, 175,30) ;	
	_name.addActionListener(new mkSearchAction(_app)) ;

	_panel.add(_name) ;

	lb = new JLabel("{") ;
	lb.setBounds(5, 85, 100,30) ;
	_panel.add(lb) ;

	_jname = new JTextField() ;
	_jname.setBounds(115,85, 175,30) ;	
	_panel.add(_jname) ;

	//	lb.setBounds(5, 125, 100,30) ;

	_lmodel = new DefaultListModel[26] ;
	for(int i = 0; i < 26; i++){
	    _lmodel[i] = new DefaultListModel() ;
	}
	
	_list = new JList(_lmodel) ;

	_list.addListSelectionListener(new ListSelectionListener(){
		public void valueChanged(ListSelectionEvent e)
		{
		    setCard(e) ;
		}
	    }) ;
	
	JScrollPane spane = new JScrollPane(_list) ;
	spane.setBounds(5,125, 290, 270) ;	
        spane.setVerticalScrollBarPolicy(
			  JScrollPane.VERTICAL_SCROLLBAR_ALWAYS) ;
        spane.setPreferredSize(new Dimension(590, 270));
        spane.setBorder(
            BorderFactory.createCompoundBorder(
                BorderFactory.createCompoundBorder(
                                BorderFactory.createTitledBorder("Xg"),
                                BorderFactory.createEmptyBorder(5,5,5,5)),
                spane.getBorder()));	
	_panel.add(spane) ;

	clear()	;

	return getPanel() ;
    }

    public DefaultListModel getDefaultListModel(String name)
    {
	char c = Character.toUpperCase(name.charAt(0)) ;

	return _lmodel[c - 'A'] ;
    }

	
    public void selectList(String name)
    {
	DefaultListModel mo = getDefaultListModel(name) ;

	_list.setModel(mo) ;
    }


    public mkCard createNewCard()
    {
	String name = getName() ;

	if(name == null){
	    return null ;
	}

	mkCard nuCard = new mkCard(name, 
				   getJName(),
				   _app.getRightWidget().getBody()) ;

	DefaultListModel mo = getDefaultListModel(name) ;

	if(! mo.contains(nuCard)){
	    setUpdateFlag(true) ;
	    mo.addElement(nuCard) ;
	    _list.setModel(mo) ;
	    _cuCard = nuCard ;
	} else {
	    int idx = mo.indexOf(name) ;
	}

	return nuCard ;
    }

    public mkCard getCurrentCard()
    {
	return _cuCard ;
    }


    public void delCard()
    {
	String name = getName() ;

	if(name == null){
	    return ;
	}

	mkCard dCard = new mkCard(name, "", "") ;

	DefaultListModel mo = getDefaultListModel(name) ;

	if(mo.contains(dCard)){
	    mo.removeElement(dCard) ;
	    _list.setModel(mo) ;
	    _cuCard = null ;
	} 
	clear() ;
    }


    public void updateCard()
    {
	if(_cuCard == null){
	    return ;
	}

	if(_cuCard.getName().equals(getName())){
	    _cuCard.setJName(getJName()) ;
	    _cuCard.setBody(_app.getRightWidget().getBody()) ;
	}
    }

    public void searchCard()
    {
	String name = getName() ;

	if(name == null){
	    return ;
	}

	mkCard sCard = new mkCard(name, "", "") ;

	DefaultListModel mo = getDefaultListModel(name) ;

	_list.setModel(mo) ;
	if(mo.contains(sCard)){
	    mkCard tcard = (mkCard )mo.get(mo.indexOf(sCard)) ;
	    tcard.incrCount() ;
	    _list.setSelectedValue(tcard, true) ;
	    _cuCard = null ;
	    setUpdateFlag(true) ;
	} 
    }



    public void setCard(ListSelectionEvent e)
    {
	updateCard() ;

	Object obj = _list.getSelectedValue() ;

	setCard((mkCard )obj) ;
    }

    public void setCard(mkCard arg)
    {
	if(arg == null) return ;

	_cuCard = arg ;

	setJName(arg.getJName()) ;

	setName(arg.getName()) ;

	_app.getRightWidget().setBody(arg.getBody()) ;

	_app.getRightWidget().setCount(arg.getCount()) ;
    }

    public void clear()
    {
	setUpdateFlag(false) ;

	setName("") ;
	setJName("") ;

	_cuCard = null ;
    }	

    public void loadFile(String arg) throws Exception
    {
	FileInputStream fis = new FileInputStream(arg) ;
	ObjectInputStream is = 
	    new ObjectInputStream(new BufferedInputStream(fis)) ;

	_lmodel = (DefaultListModel[] )is.readObject() ;

	clear() ;
    }

    public void saveFile(String arg) throws Exception
    {
	FileOutputStream fos = new FileOutputStream(arg) ;
	ObjectOutputStream os = 
	    new ObjectOutputStream(new BufferedOutputStream(fos)) ;

	os.writeObject(_lmodel) ;

	os.close() ;
    }

    public void startSearch()
    {
	_name.setText("") ;
	_jname.setText("") ;
	_name.requestFocus() ;
    }

}

