/*
  copyright(c) 2004  Miki Akiyoshi
  
  This file is part of Miki English Study.
  
  Miki English Study is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  Miki English Study is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with Miki English Study; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  
*/

package jp.dip.ikim.englishstudy ;

import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import java.util.prefs.Preferences ;

public class mkLookAndFeelAction implements ActionListener
{
    static final String[] lf = {
	"com.sun.java.swing.plaf.windows.WindowsLookAndFeel",
	"com.sun.java.swing.plaf.gtk.GTKLookAndFeel",
	"javax.swing.plaf.metal.MetalLookAndFeel",
	"com.sun.java.swing.plaf.motif.MotifLookAndFeel",
    } ;

    static final String key = "LOOK_AND_FEEL" ;

    mkApplet  _app ;
    int       _no ;

    public mkLookAndFeelAction(mkApplet arg, int no)
    {
	_app = arg ;

	_no = no ;
    }

    public void actionPerformed(ActionEvent e)
    {
	Preferences pref = _app.getPreferences() ;

	try {
	    UIManager.setLookAndFeel(lf[_no]) ;
	    SwingUtilities.updateComponentTreeUI(_app) ;
	} catch(Exception ex){
	    return ;
	}

	pref.putInt(key, _no) ;
    }

    static int init(mkApplet app) throws Exception 
    {
	Preferences pref = app.getPreferences() ;

	int no = pref.getInt(key, 0) ;

	UIManager.setLookAndFeel(lf[no]) ;

	return no ;
    }
}

